/*****************************************************************************/
/*       (C) 1993,1994 R. NADE - M. GRANDCHAMP - All Rights Reserved         */
/*****************************************************************************/
/*    This source-code is NOT public domain nor Freeware, this is part of    */
/*              'The C Programming Package' which is Shareware.              */
/*   If you use this code, please register and get a free Full-VGA version   */
/*****************************************************************************/
                        /*----------------------*
                         *      CPPFIC1B.C      *
                         *     FILE MANAGER     *
                         *   Second Part 2/2    *
                         *----------------------*/

 /* Included Files */
 # include <stdio.h>
 # include <io.h>
 # include <dos.h>
 # include <fcntl.h>
 # include <bios.h>
 # include <stdlib.h>
 # include <conio.h>
 # include <dir.h>
 # include <string.h>
 # include <alloc.h>
 # include <mem.h>

 /* Global Variables */
 extern int bm,i,j,k,l,m,n,t,x,x1,x2,xm,y,y1,y2,ym,z,menu0,menu1,return1;
 extern int colour1,colour2,colour3,colour4,colour5,nbdisk,return2,return3;
 extern int lline,linemax,choice,modif,pfdiv,beginningfile,endfile;
 extern unsigned int ref,nbref;
 extern long depdiv;
 extern unsigned char c0,c1,trashcan[],path[],nc1[],trashret[],filedir[];
 extern struct ffblk ffblk;
/* extern struct directory directory; */
 extern char *beginning,*theend,*memory;
 extern struct directory{
                       unsigned char name[9];
                       unsigned char ext[4];
                       unsigned char size[9];
                       unsigned char attribut[2];
                       unsigned char date[9];
                       unsigned char time[6];
                     } directory;

 /*-------------------------*
  * DISPLAY DIRECTORY FILES *
  *-------------------------*/
  void display_directory_files()
    {
      textattr(colour4);               lline=3;
      if(nbref<19)                     i=nbref;
      else                             i=18;
      /* Erase the current window */
      window(24,4,65,21);              clrscr();
      window(1,1,80,25);
      for(j=0; j<i; j++){
        memcpy(&directory,memory,39);  memory+=39;
        if(memory>theend){
          memory=theend-39;            endfile=1;
	  return;
	}
        lline++;
        gotoxy(24,lline);              cputs(directory.name);
        gotoxy(33,lline);              cputs(directory.ext);
        if(directory.attribut[0]==0x10){
          /* Directory */
          gotoxy(37,lline);            cputs("<Directory>");
	}
	else{
          /* File  */
          gotoxy(38,lline);            cputs(directory.size);
          if((directory.attribut[0] & 0x20)==0x20){
          /* Record */
            gotoxy(50,lline);          cputs("A");
	  }
        if((directory.attribut[0] & 0x01)==0x01){
          /* Read Only R or R+A */
            gotoxy(49,lline);          cputs("R");
	  }
          if((directory.attribut[0] & 0x02)==0x02){
          /* Hidden */
            gotoxy(48,lline);          cputs("H");
	  }
          if((directory.attribut[0] & 0x04)==0x04){
          /* System */
            gotoxy(47,lline);          cputs("S");
	  }
	}
        gotoxy(52,lline);              cputs(directory.date);
        gotoxy(61,lline);              cputs(directory.time);
      }
      /* Back to the first line and to this file */
      /* in the array in memory                  */
      /* Store the last line number              */
      memory-=(39*(lline-3));
      linemax=lline;                   lline=4;
    }
 /*----------------------*
  * STORE FILE IN MEMORY *
  *----------------------*/
  void store_file_in_memory()
    {
      /* Get :                                 */
      /* 1 The name and extension of the file  */
      /* Fill up with blanks before getting    */
      strnset(trashcan,0x00,37);       strcpy(trashcan,ffblk.ff_name);
      /* Get the file name */
      strcpy(trashret,trashcan);       strtok(trashret,".");
      left_justify_the_text(trashret,8);
      memcpy(memory,trashret,9);      memory+=9;
      /* Get the extension */
      i=strlen(trashcan);
      /* Get the number of chars of the extension */
      for(k=0; k<5; k++){
        c0=trashcan[i-k-1];
	if(c0==0x2e)                   break;
      }
      if(k<4){
	for(j=0; j<k; j++){
          nc1[j]=trashcan[i-k+j];
	}
	for(j=k; j<4; j++)             nc1[j]=0x20;
      }
      else{
	for(j=0; j<3; j++)             nc1[j]=0x20;
      }
      /* Save the extension */
      left_justify_the_text(nc1,3);
      memcpy(memory,trashret,4);      memory+=4;
      /* Size of the file */
      ltoa(ffblk.ff_fsize,nc1,10);     right_justify_the_text(nc1,8);
      memcpy(memory,trashret,9);      memory+=9;
      /* File attribute */
      nc1[0]=ffblk.ff_attrib;
      memcpy(memory,nc1,2);           memory+=2;
      /* Get the Update date of the file */
      ref=ffblk.ff_fdate;
      /* Get the day */
      i=ref & 0x1f;                    strset(nc1,0x20);
      itoa(i,nc1,10);                  nc1[2]=0x00;
      if(i<10){
	nc1[1]=nc1[0];                 nc1[0]=0x30;
      }
      strcpy(trashcan,nc1);            strcat(trashcan,"/");
     /* Get the month */
      i=(ref & 0x1e0) >>5;             strset(nc1,0x20);
      itoa(i,nc1,10);                  nc1[2]=0x00;
      if(i<10){
	nc1[1]=nc1[0];                 nc1[0]=0x30;
      }
      strcat(trashcan,nc1);            strcat(trashcan,"/");
     /* Get the year */
      i=ref >>9;                       strset(nc1,0x20);
      j=80+i;                          itoa(j,nc1,10);
      nc1[2]=0x00;                     strcat(trashcan,nc1);
      memcpy(memory,trashcan,9);       memory+=9;
      /* Update time */
      ref=ffblk.ff_ftime;
      i=ref >> 11;                     itoa(i,nc1,10);
      nc1[2]=0x00;
      if(i<10){
	nc1[1]=nc1[0];                 nc1[0]=0x30;
      }
      strcpy(trashcan,nc1);            strcat(trashcan,":");
      i=(ref & 0x7e0) >> 5;            itoa(i,nc1,10);
      if(i<10){
	nc1[1]=nc1[0];                 nc1[0]=0x30;
      }
      nc1[2]=0x00;                     strcat(trashcan,nc1);
      memcpy(memory,trashcan,6);       memory+=6;
      /* Copy all things in the allocated memory     */
      /* and the incrementation of the files counter */
      /* in the same time to distinguish the fields  */
      nbref++;
    }
 /*---------------------*
  * GET DIRECTORY FILES *
  *---------------------*/
  void get_directory_files()
    {
      /* Reset the counters to 0 */
      memory=beginning;                     nbref=0;
      beginningfile=1;                      endfile=0;
      /* All the blanks are replaced by spaces for the recuperation */
      /* First get the new directory                                */
      getcwd(path,64);               nbref=0;
      /* Then store in the listing all the directory files */
      /* And had the sub-directories (Attribute 0x10)      */
      /* And the hidden or system files (Attribute 0x37)   */
      i=findfirst("*.*",&ffblk,0x37);
      /* If we found something we store it in RAM  */
      while(i>-1){
        store_file_in_memory();
	i=findnext(&ffblk);
      }
      /* we get the address of the last reference */
      theend=memory;
      /* We calculate the size of the files and display it */
      calculate_and_display_sum_of_files();
      /* back to the beginning and display the first 19 */
      memory=beginning;                   modif=0;
      display_directory_files();
    }
 /*----------------------*
  * DISPLAY CURRENT LINE *
  *----------------------*/
  void display_current_line()
    {
      /* We display the line that concerns the file       */
      /* pointed in the array in memory, in inverse video */
      textattr(colour5);
      memcpy(&directory,memory,39);
      gotoxy(24,lline);                cputs(directory.name);
      gotoxy(33,lline);                cputs(directory.ext);
      if(directory.attribut[0]==0x10){
        /* Directory */
        gotoxy(37,lline);              cputs("<Directory>");
      }
      else{
        /* File */
        gotoxy(38,lline);              cputs(directory.size);
        if((directory.attribut[0] & 0x20)==0x20){
          /* Record */
          gotoxy(50,lline);            cputs("A");
	}
        if((directory.attribut[0] & 0x01)==0x01){
          /* Read Only R or R+A */
          gotoxy(49,lline);            cputs("R");
	}
        if((directory.attribut[0] & 0x02)==0x02){
          /* Hidden */
          gotoxy(48,lline);            cputs("H");
	}
        if((directory.attribut[0] & 0x04)==0x04){
          /* System */
          gotoxy(47,lline);            cputs("S");
	}
      }
      gotoxy(52,lline);                cputs(directory.date);
      gotoxy(61,lline);                cputs(directory.time);
    }
 /*---------------------*
  * DISPLAY NORMAL LINE *
  *---------------------*/
  void display_normal_line()
    {
      /* We display the line that concerns the pointed file */
      /* in the array in memory, in normal attributes       */
      textattr(colour4);
      memcpy(&directory,memory,39);
      gotoxy(24,lline);                cputs(directory.name);
      gotoxy(33,lline);                cputs(directory.ext);
      if(directory.attribut[0]==0x10){
        /* Directory */
        gotoxy(37,lline);              cputs("<Directory>");
      }
      else{
        /* File */
        gotoxy(38,lline);              cputs(directory.size);
        if((directory.attribut[0] & 0x20)==0x20){
          /* Record */
          gotoxy(50,lline);            cputs("A");
	}
        if((directory.attribut[0] & 0x01)==0x01){
          /* Read only R or R+A */
          gotoxy(49,lline);            cputs("R");
	}
        if((directory.attribut[0] & 0x02)==0x02){
          /* Hidden */
          gotoxy(48,lline);            cputs("H");
	}
        if((directory.attribut[0] & 0x04)==0x04){
          /* System */
          gotoxy(47,lline);            cputs("S");
	}
      }
      gotoxy(52,lline);                cputs(directory.date);
      gotoxy(61,lline);                cputs(directory.time);
    }
 /*----------------------------*
  * SCROLLING IN THE DIRECTORY *
  *----------------------------*/
  void scrolling_in_the_directory()
    {
      if(choice==1){
        /* Go the beginning of the directory */
        if(beginningfile){
          sound1();                       return;
	}
        memory=beginning;                 display_directory_files();
        sound1();                         beginningfile=1;
        endfile=0;                        return;
      }
      if(choice==2){
        /* Back of a page length (18 lines) */
        if(beginningfile){
          sound1();                      return;
	}
        memory-=702;
        if((memory<beginning)||(memory>theend)){
          /* Case of the pointers : the offset, when back to zero,       */
          /* take a high value if the beginning of the offset            */
          /* is near zero (segment:offset)                               */
          /* The reason is that the value of the segment is not modified */
          /* by the substraction...                                      */
          memory=beginning;               beginningfile=1;
          sound1();
	}
        display_directory_files();
        endfile=0;       return;
      }
      if(choice==3){
        /* Back of a line */
           display_normal_line();
           if(lline==4){
        /* First line, go back and display the page */
          memory-=39;
          if((memory<beginning)||(memory>theend)){
            memory=beginning;             beginningfile=1;
            sound1();
	  }
          display_directory_files();
          memory-=(39*(lline-4));     lline=4;
	}
	else{
          /* Not the first line, back of a line */
          lline--;                     memory-=39;
          if((memory<beginning)||(memory>theend)){
            memory=beginning;             beginningfile=1;
            sound1();                    lline=4;
	  }
	}
        endfile=0;
      }
      if(choice==4){
        /* Go to next line */
        if(memory==theend-39){
          /* End of the file */
          sound1();                      return;
	}
        display_normal_line();
        if(lline==21){
          /* Last line */
          memory-=624;
          if((memory<beginning)||(memory>theend)){
            memory=beginning;             sound1();
            beginningfile=1;                endfile=0;
	  }
          display_directory_files();
          lline=21;                    memory+=663;
	}
	else{
          /* Not the last line, go to the next line */
          lline++;                     memory+=39;
          if(memory>(theend-39)){
            lline--;
            memory=theend-39;            sound1();
            endfile=1;
	  }
	}
        beginningfile=0;
      }
      if(choice==5){
        /* go to the next page (18 lines or the page) */
        if(endfile){
          sound1();                      return;
	}
        memory+=((22-lline)*39);
        if(memory>(theend-39)){
          memory=theend-39;              sound1();
          endfile=1;
	}
        display_directory_files();
        beginningfile=0;                 return;
      }
      if(choice==6){
        /* Go at the end of the directory */
        if(endfile){
          sound1();                      return;
	}
        beginningfile=0;                    memory=theend-702;
        if((memory<beginning)||(memory>theend)){
          memory=beginning;               sound1();
          beginningfile=1;                  endfile=0;
	}
        display_directory_files();
        sound1();                        lline=i+3;
        memory=theend-39;                endfile=1;
	return;
      }
    }
 /*----------------------------------*
  * COPY THE FULL NAME OF THE FILE   *
  *----------------------------------*/
  void copy_the_full_name_of_the_file()
    {
      /* Purpose : get the whole name of the working file */
      strcpy(filedir,path);
      if(strlen(path)>3)             strcat(filedir,"\\");
      memcpy(&directory,memory,39);      strcat(filedir,directory.name);
      /* Cut the final spaces which we had put to get  */
      /* constant length records and so ease           */
      /* the array management and the display          */
      for(j=0; j<64; j++){
        c0=filedir[j];
	if(c0==0x20){
          filedir[j]=0x00;             break;
	}
      }
      if(directory.ext[0]!=0x20){
        strcat(filedir,".");           strcat(filedir,directory.ext);
      }
      /* Cf above */
      for(j=0; j<64; j++){
        c0=filedir[j];
	if(c0==0x20){
          filedir[j]=0x00;             break;
	}
      }
      blank_line_25();             textattr(colour5);
      gotoxy(1,25);                    cputs("Selection=");
      gotoxy(11,25);                   cputs(filedir);
    }
 /*--------------------------*
  * DELETE THE SELECTED FILE *
  *--------------------------*/
  void delete_the_selected_file()
    {
      k=message(" Confirm"," the destruction"," of the file "," on the last line","Y/N");
      if(k==34){
        /* We answered Y/y for YES */
        i=remove(filedir);
	if(i<0)
          warning(" Cannot delete"," the file:"," file not found","    or"," Access denied");
	else{
          /* We need to re-display the page without the canceled file */
          /* to match the current directory                           */
          t=lline;                     memory-=39*(lline-5);
          get_directory_files();
          lline=t;                     memory+=39*(lline-4);
	}
      }
    }
 /*----------------------*
  * COMPARE (sort names) *
  *----------------------*/
  int compare(a,b)
    char *a,*b;
    {
      return(strncmp(a,b,8));
    }
 /*---------------------------*
  * ACTION ON FILES LISTING *
  *---------------------------*/
  void action_on_files_listing()
    {
      if(choice==7){
       /* Select the file under the cursor and */
       /* copy the full name with path in "filedir" */
        copy_the_full_name_of_the_file();
        if(directory.attribut[0]==0x10){
          /* If it is a directory Change of directory */
          directory_changing();
          get_directory_files();
	}
	else{
          /* It is a file, we display it */
          /* Cf in CPPFIC4.C. */
          display_selected_file();
	}
      }
      if(choice==8){
        /* Sort the directory listing */
        memory=beginning;                 qsort(memory,nbref,39,compare);
        memory=beginning;                 display_directory_files();
      }
      if(choice==9){
        /* Delete a directory file */
        copy_the_full_name_of_the_file();
        delete_the_selected_file();
      }
      if(choice==10){
        /* Record a file */
        /* Cf in CPPFIC2A.C    */
        recording_of_the_selected_file();
      }
    }
/*************************
 * End of the Module *//*----------------------*/
